-- ATTENTION
-- Ce script doit être exécuter sur 1 User qui a le rôle de DBA (ex.: User GRHUM)
-- USER SQL


--
-- Patch DBA de SCO_SCOLARITE du 15/03/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;
--
--
-- Fichier : 1/11
-- Type : DML
-- Schema : SCO_SCOLARITE
-- Numero de version : 0.1.0.5
-- Date de publication : 15/03/2013
-- Auteur(s) : Association Cocktail
--
--
WHENEVER SQLERROR EXIT SQL.SQLCODE;

------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------ MISE A JOUR DES FOREIGN KEY  ------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------

--REGROUPEMENT--
ALTER TABLE SCO_SCOLARITE.REGROUPEMENT DROP CONSTRAINT FK_REGROUPEMENT_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.REGROUPEMENT ADD CONSTRAINT FK_REGROUPEMENT_COMPOSANTID FOREIGN KEY (ID_REGROUPEMENT) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--UE--
ALTER TABLE SCO_SCOLARITE.UE DROP CONSTRAINT FK_UE_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.UE ADD CONSTRAINT FK_UE_COMPOSANTID FOREIGN KEY (ID_UE) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--EC--
ALTER TABLE SCO_SCOLARITE.EC DROP CONSTRAINT FK_EC_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.EC ADD CONSTRAINT FK_EC_COMPOSANTID FOREIGN KEY (ID_EC) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--AP--        
ALTER TABLE SCO_SCOLARITE.AP DROP CONSTRAINT FK_AP_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.AP ADD CONSTRAINT FK_AP_COMPOSANTID FOREIGN KEY (ID_AP) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--AE--
ALTER TABLE SCO_SCOLARITE.AE DROP CONSTRAINT FK_AE_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.AE ADD CONSTRAINT FK_AE_COMPOSANTID FOREIGN KEY (ID_AE) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--DIPLOME--                
ALTER TABLE SCO_SCOLARITE.DIPLOME DROP CONSTRAINT FK_DIPLOME_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.DIPLOME ADD CONSTRAINT FK_DIPLOME_COMPOSANTID FOREIGN KEY (ID_DIPLOME) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--VERSION_DIPLOME--                  	
ALTER TABLE SCO_SCOLARITE.VERSION_DIPLOME DROP CONSTRAINT FK_VERSION_DIPLOME_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.VERSION_DIPLOME ADD CONSTRAINT FK_VERSION_DIPLOME_COMPOSANTID FOREIGN KEY (ID_VERSION_DIPLOME) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--PERIODE                  	    
ALTER TABLE SCO_SCOLARITE.PERIODE DROP CONSTRAINT FK_PERIODE_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.PERIODE ADD CONSTRAINT FK_PERIODE_COMPOSANTID FOREIGN KEY (ID_PERIODE) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT) DEFERRABLE INITIALLY DEFERRED;

--PARCOURS--                  	    
ALTER TABLE SCO_SCOLARITE.PARCOURS DROP CONSTRAINT FK_PARCOURS_COMPOSANTID;
ALTER TABLE SCO_SCOLARITE.PARCOURS ADD CONSTRAINT FK_PARCOURS_COMPOSANTID FOREIGN KEY (ID_PARCOURS) REFERENCES SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT)DEFERRABLE INITIALLY DEFERRED;


-- TABLE SELECTION_LIEN_DESCRIPTIF
declare
  is_table_exists int;
  is_seq_exists int;
begin   
  select count(*) into is_table_exists from all_tables where owner = 'SCO_SCOLARITE' and table_name = 'SELECTION_LIEN_DESCRIPTIF';
  if (is_table_exists = 1) then
    EXECUTE IMMEDIATE('DROP TABLE SCO_SCOLARITE.SELECTION_LIEN_DESCRIPTIF');
  end if;
end;
/

CREATE TABLE SCO_SCOLARITE.SELECTION_LIEN_DESCRIPTIF (
    LIEN_ID NUMBER(38) NOT NULL,
    DESCRIPTIF_ID NUMBER(38) NOT NULL,
    CONSTRAINT PK_SEL_LIEN_DESCRIPTIF PRIMARY KEY (LIEN_ID, DESCRIPTIF_ID) USING INDEX TABLESPACE INDX_CKTL_SCOL,
    CONSTRAINT FK_SEL_LIEN_DESCRIPTIF_LIEN FOREIGN KEY (LIEN_ID) REFERENCES SCO_SCOLARITE.LIEN (ID_LIEN) DEFERRABLE INITIALLY DEFERRED,        
    CONSTRAINT FK_SEL_LIEN_DESCRIPTIF_DESC FOREIGN KEY (DESCRIPTIF_ID) REFERENCES SCO_SCOLARITE.DESCRIPTIF (ID_DESCRIPTIF) DEFERRABLE INITIALLY DEFERRED
);
COMMENT ON TABLE SCO_SCOLARITE.SELECTION_LIEN_DESCRIPTIF IS 'Table de jointure entre un lien et un descriptif (un lien sélectionne un descriptif d''un composant pour le syllabus)';
COMMENT ON COLUMN SCO_SCOLARITE.SELECTION_LIEN_DESCRIPTIF.LIEN_ID IS 'Lien (lien avec la table LIEN)';
COMMENT ON COLUMN SCO_SCOLARITE.SELECTION_LIEN_DESCRIPTIF.DESCRIPTIF_ID IS 'Descriptif sélectionné (lien avec la table DESCRIPTIF)';

  
--GRADE_UNIVERSITAIRE
declare
  is_column_exists int;
begin 
  Select count(*) into is_column_exists from all_tab_cols where column_name = 'FILIERE' and table_name = 'GRADE_UNIVERSITAIRE';
  if (is_column_exists  = 0) then
     execute immediate 'ALTER TABLE SCO_SCOLARITE.GRADE_UNIVERSITAIRE ADD (FILIERE VARCHAR2(10) DEFAULT ''G'')';
    execute immediate 'COMMENT ON COLUMN SCO_SCOLARITE.GRADE_UNIVERSITAIRE.FILIERE IS ''Indique si le grade provient de la table SCOL_FORMATION_FILIERE (F) ou de la table SCOL_FORMATION_GRADE (G)''';
  end if;
end;
/

-- REGLE_LIAISON  
declare
  is_column_exists int;
begin 
  Select count(*) into is_column_exists from all_tab_cols where column_name = 'ALLOWED' and table_name = 'REGLE_LIAISON';
  if is_column_exists  = 0 then
    execute immediate ' ALTER TABLE SCO_SCOLARITE.REGLE_LIAISON ADD (ALLOWED  NUMBER DEFAULT 1)  ';
    execute immediate 'COMMENT ON COLUMN SCO_SCOLARITE.REGLE_LIAISON.ALLOWED IS ''Indique si la règle de liaison est bien autorisée''';
  end if;
end;
/
------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------ Table pour Coriandre  ------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- TABLE TYPE_INSCRIPTION
declare
  is_table_exists int;
  is_seq_exists int;
begin 
  select count(*) into is_table_exists from all_tables where owner = 'SCO_SCOLARITE' and table_name = 'TYPE_INSCRIPTION';
  if (is_table_exists = 1) then
    EXECUTE IMMEDIATE('DROP TABLE SCO_SCOLARITE.TYPE_INSCRIPTION');
  end if;
  
  select count(*) into is_seq_exists from all_sequences where sequence_name= 'TYPE_INSCRIPTION_SEQ';
  if (is_seq_exists = 1) then
    execute immediate('DROP SEQUENCE SCO_SCOLARITE.TYPE_INSCRIPTION_SEQ');
  end if;
end;
/
-- TABLE TYPE_INSCRIPTION
CREATE TABLE SCO_SCOLARITE.TYPE_INSCRIPTION (
	ID_TYPE_INSCRIPTION NUMBER(38) NOT NULL,
	LC_TYPE_INSCRIPTION VARCHAR2(8),
	LL_TYPE_INSCRIPTION VARCHAR2(255),
	D_CREATION DATE  NOT NULL, 
	D_MODIFICATION DATE, 
	PERS_ID_CREATION NUMBER  NOT NULL, 
	PERS_ID_MODIFICATION NUMBER,
 	CONSTRAINT PK_TYPE_INSCRIPTION PRIMARY KEY (ID_TYPE_INSCRIPTION) USING INDEX TABLESPACE INDX_CKTL_SCOL
);
CREATE SEQUENCE SCO_SCOLARITE.TYPE_INSCRIPTION_SEQ START WITH 4;
COMMENT ON TABLE SCO_SCOLARITE.TYPE_INSCRIPTION IS 'Table de nomenclature pour définir les types d''inscription';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.ID_TYPE_INSCRIPTION IS 'Id origine des ressources ';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.LC_TYPE_INSCRIPTION IS ' Libellé court type d''inscription ';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.Ll_TYPE_INSCRIPTION IS ' Libellé long type d''inscription ';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.D_CREATION IS 'Date de creation de lenregistrement.';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.D_MODIFICATION IS 'Date de la derniere modification de lenregistrement.';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN SCO_SCOLARITE.TYPE_INSCRIPTION.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement';
  
-- TABLE CURSUS
declare
  is_table_exists int;
  is_seq_exists int;
begin 
  select count(*) into is_table_exists from all_tables where owner = 'SCO_SCOLARITE' and table_name = 'CURSUS';
  if (is_table_exists = 1) then
    EXECUTE IMMEDIATE('DROP TABLE SCO_SCOLARITE.CURSUS');
  end if;
  
  select count(*) into is_seq_exists from all_sequences where sequence_name= 'CURSUS_SEQ';
  if (is_seq_exists = 1) then
    execute immediate('DROP SEQUENCE SCO_SCOLARITE.CURSUS_SEQ');
  end if;
end;
/
--TABLE CURSUS --
GRANT REFERENCES ON GRHUM.RNE TO SCO_SCOLARITE;
CREATE TABLE SCO_SCOLARITE.CURSUS (	
	ID_CURSUS NUMBER(38)  NOT NULL, 
	ID_ETUDIANT NUMBER(38) NOT NULL,
	ANNEE_DEBUT NUMBER(38) NOT NULL, 
	ANNEE_FIN NUMBER(38) NOT NULL, 
	C_RNE VARCHAR2(8),
	ACCES_TITRE VARCHAR2(100),
	ACCES_MENTION VARCHAR2(100),
	FORMATION VARCHAR2(255),
	NIVEAU NUMBER(38),
	GRADE NUMBER(38),
	TYPE NUMBER(38),
	DIPLOME VARCHAR2(255),
	TYPE_INSCTRIPTION VARCHAR(255),
	INTERRUPTION_ETUD NUMBER(1) DEFAULT 0, 
	D_CREATION DATE  NOT NULL, 
	D_MODIFICATION DATE, 
	PERS_ID_CREATION NUMBER(38) , 
	PERS_ID_MODIFICATION NUMBER(38),
	PRIMARY KEY (ID_CURSUS)  
);
	CREATE SEQUENCE SCO_SCOLARITE.CURSUS_SEQ START WITH 1;
	
	COMMENT ON TABLE SCO_SCOLARITE.CURSUS  IS 'Table contenant le cursus de l''étudiant .';
	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ID_CURSUS IS 'cle primaire';
	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ID_ETUDIANT IS 'id de la table de pre_etudiant';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ANNEE_DEBUT IS 'annéee de début de période';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ANNEE_FIN IS 'annéee de fin de période';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.C_RNE IS 'correspond au code rne (table GRHUMµ.RNE) de l''établissement';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ACCES_TITRE IS 'Titre d''accès à létablissement';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.ACCES_MENTION IS 'mention du titre d''accès';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.FORMATION IS 'intutilé de la formation suivie';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.NIVEAU IS 'niveau de la formation suivi';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.GRADE IS 'grade de la formation suivi';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.TYPE IS 'type de la formation suivi';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.DIPLOME IS 'diplome obtenu';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.TYPE_INSCTRIPTION IS 'type d''inscription  (ES = Enseignement supérieur, Fr. = Université française, Local = Université de l''IA)';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.INTERRUPTION_ETUD IS 'Interruption des études';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.D_CREATION IS 'Date de creation de l''enregistrement.';
	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.D_MODIFICATION IS 'Date de la derniere modification de l''enregistrement.';
 	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement';
	COMMENT ON COLUMN SCO_SCOLARITE.CURSUS.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement';

	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_ETUDIANT FOREIGN KEY (ID_ETUDIANT) REFERENCES GRHUM.ETUDIANT DEFERRABLE INITIALLY DEFERRED;
	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_C_RNE FOREIGN KEY (C_RNE) REFERENCES GRHUM.RNE DEFERRABLE INITIALLY DEFERRED;
	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_GRADE FOREIGN KEY (GRADE) REFERENCES SCO_SCOLARITE.GRADE_UNIVERSITAIRE DEFERRABLE INITIALLY DEFERRED;
	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_TYPE FOREIGN KEY (TYPE) REFERENCES SCO_SCOLARITE.TYPE_FORMATION DEFERRABLE INITIALLY DEFERRED;
	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_PERSONNE FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE DEFERRABLE INITIALLY DEFERRED;
	ALTER TABLE SCO_SCOLARITE.CURSUS ADD CONSTRAINT FK_CURSUS_PERSONNE2 FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE DEFERRABLE INITIALLY DEFERRED;

             	    
